/*
** Copyright (C) 3 January 2000 George Saj <gsaj@acm.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "config.h"

#ifndef _GUI_H
#define _GUI_H
#define NUM_SIGNALS 10

typedef enum { ALL_USR, CUR_USR, PCK_USR } UserListEnum;
typedef enum { Sort_Meth_Num, Sort_Meth_Str, Sort_Meth_Time } SortMethEnum;

typedef struct _SignalStruct {
     gchar* sig_name;
     int sig_val;
} SignalStruct;


typedef struct _GuiElements {
     GtkWidget *window; 
     GtkWidget *clist1; 
     gshort selected_row;
     GtkWidget *separator; 
     GtkWidget *vbox1;
     GtkWidget *button;
     GtkWidget *menubar;
     GtkWidget *scrollwindow;  
     GtkWidget *hbox1;
     GtkWidget *sigopmenu;
     GtkWidget *sigmenu;
     GtkWidget *sigmenuitem;
} GuiElements;

typedef struct _Columnitem {
     GtkWidget *checkitem;
     gint column_num;
     gboolean column_val;
} Columnitem;


typedef struct _PrefsGui {
    GtkWidget *dialog;
    GtkWidget *button;
    GtkWidget *add_button;
    GtkWidget *del_button;
    GtkWidget *clr_button;
    GtkWidget *notebook;
    GtkWidget *vbox1;
    GtkWidget *vbox2;
    GtkWidget *hbox1;
    GtkWidget *scrollwindow;
    GtkWidget *radiobutton1; 
    GtkWidget *radiobutton2;
    GtkWidget *radiobutton3;
    GtkWidget *uname_entry;
    GSList *uid_rgroup;
    GtkWidget *userClist; /* now a CList, folks! */
    GList *ulist;
    gshort selected_list_item;
    Columnitem col[NUMCOL];
    UserListEnum ulist_opt; /* a temporary to store user filters */
} PrefsGui;


typedef struct _appCfg {
    UserListEnum ulist_option;
    GList *inc_ulist;
    gboolean showed_columns[NUMCOL];
    gshort clist_sort_col;
    GtkSortType clist_sort_type;
    SortMethEnum clist_sort_meth;
    
} appCfg;


extern appCfg appstate; /* this containts the universally accessible list */

GtkWidget *get_main_menu(GtkWidget *window);
GtkWidget *create_simple_dialog(gchar *title);
void remove_grab(GtkWidget *widget, gpointer data);
void close_simple_dialog(GtkWidget *widget, gpointer data);
gboolean* get_showed_columns();

void select_row_callback(GtkWidget *widget, gint row,
			 gint column, GdkEventButton *event,
			 gpointer data);
GtkWidget *init_clist();
void gui_init();

#endif _GUI_H







